Module java.desktop
Package javax.swing.undo

## Class StateEdit

- java.lang.Object
- - javax.swing.undo.AbstractUndoableEdit
  - - javax.swing.undo.StateEdit

- All Implemented Interfaces:
    `Serializable`, `UndoableEdit`

      public class StateEdit
      extends AbstractUndoableEdit

  StateEdit is a general edit for objects that change state. Objects being edited must conform to the StateEditable interface.

  This edit class works by asking an object to store it's state in Hashtables before and after editing occurs. Upon undo or redo the object is told to restore it's state from these Hashtables.

  A state edit is used as follows:

            // Create the edit during the "before" state of the object
            StateEdit newEdit = new StateEdit(myObject);
            // Modify the object
            myObject.someStateModifyingMethod();
            // "end" the edit when you are done modifying the object
            newEdit.end();

  Note that when a StateEdit ends, it removes redundant state from the Hashtables - A state Hashtable is not guaranteed to contain all keys/values placed into it when the state is stored!

  See Also:
    `StateEditable`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected StateEditable` | `object` | The object being edited
    `protected Hashtable<Object,​Object>` | `postState` | The state information after the edit
    `protected Hashtable<Object,​Object>` | `preState` | The state information prior to the edit
    `protected static String` | `RCSID` | Obsolete RCS version identity.
    `protected String` | `undoRedoName` | The undo/redo presentation name

    - ### Fields declared in class javax.swing.undo.AbstractUndoableEdit

      `RedoName, UndoName`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StateEdit​(StateEditable anObject)` | Create and return a new StateEdit.
    `StateEdit​(StateEditable anObject, String name)` | Create and return a new StateEdit with a presentation name.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `end()` | Gets the post-edit state of the StateEditable object and ends the edit.
    `String` | `getPresentationName()` | Gets the presentation name for this edit
    `protected void` | `init​(StateEditable anObject, String name)` | Initialize the state edit.
    `void` | `redo()` | Tells the edited object to apply the state after the edit
    `protected void` | `removeRedundantState()` | Remove redundant key/values in state hashtables.
    `void` | `undo()` | Tells the edited object to apply the state prior to the edit

    - ### Methods declared in class javax.swing.undo.AbstractUndoableEdit

      `addEdit, canRedo, canUndo, die, getRedoPresentationName, getUndoPresentationName, isSignificant, replaceEdit, toString`

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### RCSID

          protected static final String RCSID

      Obsolete RCS version identity.
      See Also:
        Constant Field Values

    - #### object

          protected StateEditable object

      The object being edited

    - #### preState

          protected Hashtable<Object,​Object> preState

      The state information prior to the edit

    - #### postState

          protected Hashtable<Object,​Object> postState

      The state information after the edit

    - #### undoRedoName

          protected String undoRedoName

      The undo/redo presentation name

  - ### Constructor Detail

    - #### StateEdit

          public StateEdit​(StateEditable anObject)

      Create and return a new StateEdit.
      Parameters:
        `anObject` - The object to watch for changing state
      See Also:
        `StateEdit`

    - #### StateEdit

          public StateEdit​(StateEditable anObject,
                           String name)

      Create and return a new StateEdit with a presentation name.
      Parameters:
        `anObject` - The object to watch for changing state
        `name` - The presentation name to be used for this edit
      See Also:
        `StateEdit`

  - ### Method Detail

    - #### init

          protected void init​(StateEditable anObject,
                              String name)

      Initialize the state edit.
      Parameters:
        `anObject` - The object to watch for changing state
        `name` - The presentation name to be used for this edit

    - #### end

          public void end()

      Gets the post-edit state of the StateEditable object and ends the edit.

    - #### undo

          public void undo()

      Tells the edited object to apply the state prior to the edit
      Specified by:
        `undo` in interface `UndoableEdit`
      Overrides:
        `undo` in class `AbstractUndoableEdit`
      See Also:
        `AbstractUndoableEdit.canUndo()`

    - #### redo

          public void redo()

      Tells the edited object to apply the state after the edit
      Specified by:
        `redo` in interface `UndoableEdit`
      Overrides:
        `redo` in class `AbstractUndoableEdit`
      See Also:
        `AbstractUndoableEdit.canRedo()`

    - #### getPresentationName

          public String getPresentationName()

      Gets the presentation name for this edit
      Specified by:
        `getPresentationName` in interface `UndoableEdit`
      Overrides:
        `getPresentationName` in class `AbstractUndoableEdit`
      Returns:
        the empty string ""
      See Also:
        `AbstractUndoableEdit.getUndoPresentationName()`, `AbstractUndoableEdit.getRedoPresentationName()`

    - #### removeRedundantState

          protected void removeRedundantState()

      Remove redundant key/values in state hashtables.